import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.io.StringReader;
import java.io.StringWriter;
import java.net.Socket;

import org.enhydra.zeus.Marshaller;
import org.enhydra.zeus.result.StreamResult;

import dataObj.Push_info;
import dataObj.Push_infoImpl;
import dataObj.Resp_count;
import dataObj.Resp_countImpl;


class XMLSocketThread implements Runnable {
	private Thread _thisThread;
	private int cnt = 0;
	private TimerObj _obj;
  private  double _bid = 1.0;
  private  double _offer = 10.0;
  private  boolean _tic = false;
  private Socket _socket;
  private int loop = 0;
  
  private StringBuffer _pool = new StringBuffer();

  /**
   * socketւ̏owriter
   *
   */
  private PrintWriter _writer;


  /**
   * socket̓ǂݏoXg[
   */
  private InputStream _instream;

  /**
   * RXgN^
   */
  protected XMLSocketThread( Socket socket ) throws IOException {
	  super();
	  _socket = socket;
	  _writer = new PrintWriter(new BufferedOutputStream(_socket.getOutputStream()));
	  _instream = _socket.getInputStream();
    _obj = new TimerObj(this);
  }

  public void start() {
  	try {
	    _thisThread = new Thread(this);
	    _thisThread.start();
	    _obj.start();
  	} catch (Exception ex) {
  		ex.printStackTrace();
  	}
  }

  public void stop() {
    _thisThread = null;
  }

  public void run()  {
    Thread curThread = Thread.currentThread();
    try {
      while (_thisThread == curThread) {
      	System.out.println("PATH" + ++loop);
        boolean cnt = read();
        //  񂪑΃T[o[ɓ]
        if (! cnt) {
        	break;
        }
      }
    } catch (Exception ex) {
      ex.printStackTrace();
    }
    _obj.stop();
    System.out.println("Disconnected");
  }
  
  void receive() throws Exception{
  	String str = _pool.toString();
  	System.out.println(str);
		if (str.indexOf("<ask_count") != -1) {
			Resp_count resp = new Resp_countImpl();
			resp.setNum(++cnt);
			StringWriter writer = new StringWriter();
			StreamResult result = new StreamResult(writer);
			Marshaller marshaller = new Marshaller();
			marshaller.marshal(resp, result);
			
			String res = trimXml(writer.getBuffer().toString());
			write(res);

    }

  }

	void pushInfo() throws Exception{
		Push_info info = new Push_infoImpl();
		info.setBid(_bid);
		info.setOffer(_offer);
		if (_tic) {
			info.setStatus("green");
		} else {
			info.setStatus("red");
		}
		
		_bid += 0.1;
		_offer += 0.2;
		_tic = !_tic;
		StringWriter writer = new StringWriter();
		StreamResult result = new StreamResult(writer);
		Marshaller marshaller = new Marshaller();
		marshaller.marshal(info, result);
		
		String res = trimXml(writer.getBuffer().toString());	
		write(res);
	}

	public String trimXml(String xml) throws IOException {
		StringReader reader = new StringReader(xml);
		BufferedReader bufReader = new BufferedReader(reader);
		StringBuffer buffer = new StringBuffer();
		String line;
		while ((line = bufReader.readLine()) != null) {
			if (line.indexOf("<?xml") == -1) {
				buffer.append(line);
			}
		}
		return buffer.toString();
	}
	
	


  /**
   * _socketmsgށB
   * Flash5̋KōŌ#0tAmɏoflushsȂB
   *
   * @param  msg  String  XML
   */
  protected void write( String msg ) {
    _writer.write(msg);
    _writer.write(0);
    _writer.flush();
  }


 	private int BUFF_LEN = 200;
  /**
   * _socket當ǂݍށBǂݍ񂾕͍ŏI#0tĂ̂ŁAKvB
   *
   * @return  String  XML
   */
  protected boolean read() {
    boolean res = true;
    // buflen̂Ƃ͂ŗǂ̂H
    try {
//      int buflen = _instream.available();
//      byte[] buf = new byte[buflen + 1];
	    byte[] buf = new byte[BUFF_LEN];
      int len = _instream.read(buf);

      //  ŌɂĂ#0LN^폜
      //  NCAg̐ؒfA̕sȕ񂪔łꍇ(炵)
      //  ΍pɕ񒷃`FbN
			
			if (len > 0) {
				for (int idx =0; idx < len; idx++) { 
	      	byte ch = buf[idx];
	      	if (ch != 0) {
	      		_pool.append((char)ch);
	      	} else {
	      		receive();
	      		_pool.setLength(0);
	      	}
				}
				res = true;
			} else {
				res = false;
			}
    } catch (IOException ex) {
      System.out.println("NCAgbZ[Ws");
    } finally {
      return res;
    }
  }

  public String getHostInfo() {
    return _socket.getInetAddress().getHostAddress() + ":" + _socket.getPort();
  }


}

class TimerObj implements Runnable{
		
	private Thread _thread;
	private XMLSocketThread _parent;

  protected TimerObj( XMLSocketThread parent) throws IOException {
		super();
		_parent = parent;
  }
  
  public void start() {
    _thread = new Thread(this);
    _thread.start();
  }

  public void stop() {
  	System.out.println("Stopped");
    _thread = null;
  }

	public void run() {
    Thread curThread = Thread.currentThread();
    try {
    	while (_thread == curThread) {
    		_parent.pushInfo();
				_thread.sleep(3000);
    	}
		} catch (Exception ex) {
		}
	}
	
}
